"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DynamoDataOperation = void 0;

var _errors = require("./../helpers/errors.js");

var _utilService = require("../helpers/util-service.js");

var _loggingService = require("../helpers/logging-service.js");

var _joi = _interopRequireDefault(require("@hapi/joi"));

var _dynamodbAutoMarshaller = require("@aws/dynamodb-auto-marshaller");

var _baseJoiHelper = require("../core/base-joi-helper.js");

var _baseMixins = _interopRequireDefault(require("../core/base-mixins.js"));

var _baseSchema = require("./base-schema.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = privateMap.get(receiver); if (!descriptor) { throw new TypeError("attempted to get private field on non-instance"); } if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = privateMap.get(receiver); if (!descriptor) { throw new TypeError("attempted to set private field on non-instance"); } if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } return value; }

function _generateDynamoTableKey() {
  return _utilService.UtilService.generateDynamoTableKey();
}

var getRandom = function getRandom() {
  return ["rand", Math.round(Math.random() * 99999), Math.round(Math.random() * 88888), Math.round(Math.random() * 99)].join("");
};

function createTenantSchema(schemaMapDef) {
  return _joi["default"].object().keys(schemaMapDef).keys(_baseSchema.coreSchemaDefinition);
}

var _partitionKeyFieldName = new WeakMap();

var _sortKeyFieldName = new WeakMap();

var _dynamoDbClient = new WeakMap();

var _dynamoDb = new WeakMap();

var _schema = new WeakMap();

var _marshaller = new WeakMap();

var _tableFullName = new WeakMap();

var _segmentPartitionValue = new WeakMap();

var _secondaryIndexOptions = new WeakMap();

var DynamoDataOperation = /*#__PURE__*/function (_BaseMixins) {
  _inherits(DynamoDataOperation, _BaseMixins);

  var _super = _createSuper(DynamoDataOperation);

  //
  function DynamoDataOperation(_ref) {
    var _this;

    var dynamoDb = _ref.dynamoDb,
        schemaDef = _ref.schemaDef,
        dynamoDbClient = _ref.dynamoDbClient,
        secondaryIndexOptions = _ref.secondaryIndexOptions,
        segmentPartitionValue = _ref.segmentPartitionValue,
        tableFullName = _ref.tableFullName;

    _classCallCheck(this, DynamoDataOperation);

    _this = _super.call(this);

    _partitionKeyFieldName.set(_assertThisInitialized(_this), {
      writable: true,
      value: "partitionSegment"
    });

    _sortKeyFieldName.set(_assertThisInitialized(_this), {
      writable: true,
      value: "id"
    });

    _dynamoDbClient.set(_assertThisInitialized(_this), {
      writable: true,
      value: void 0
    });

    _dynamoDb.set(_assertThisInitialized(_this), {
      writable: true,
      value: void 0
    });

    _schema.set(_assertThisInitialized(_this), {
      writable: true,
      value: void 0
    });

    _marshaller.set(_assertThisInitialized(_this), {
      writable: true,
      value: void 0
    });

    _tableFullName.set(_assertThisInitialized(_this), {
      writable: true,
      value: void 0
    });

    _segmentPartitionValue.set(_assertThisInitialized(_this), {
      writable: true,
      value: void 0
    });

    _secondaryIndexOptions.set(_assertThisInitialized(_this), {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(_assertThisInitialized(_this), _dynamoDb, dynamoDb);

    _classPrivateFieldSet(_assertThisInitialized(_this), _dynamoDbClient, dynamoDbClient);

    _classPrivateFieldSet(_assertThisInitialized(_this), _schema, createTenantSchema(schemaDef));

    _classPrivateFieldSet(_assertThisInitialized(_this), _tableFullName, tableFullName);

    _classPrivateFieldSet(_assertThisInitialized(_this), _marshaller, new _dynamodbAutoMarshaller.Marshaller({
      onEmpty: "omit"
    }));

    _classPrivateFieldSet(_assertThisInitialized(_this), _segmentPartitionValue, segmentPartitionValue);

    _classPrivateFieldSet(_assertThisInitialized(_this), _secondaryIndexOptions, secondaryIndexOptions);

    setTimeout(function () {
      _this.allCreateTableIfNotExistsBase()["catch"](function (error) {
        console.log(error);
      });
    }, 200);
    return _this;
  }

  _createClass(DynamoDataOperation, [{
    key: "_dynamoDbClient",
    value: function (_dynamoDbClient2) {
      function _dynamoDbClient() {
        return _dynamoDbClient2.apply(this, arguments);
      }

      _dynamoDbClient.toString = function () {
        return _dynamoDbClient2.toString();
      };

      return _dynamoDbClient;
    }(function () {
      return _classPrivateFieldGet(this, _dynamoDbClient).call(this);
    })
  }, {
    key: "_dynamoDb",
    value: function (_dynamoDb2) {
      function _dynamoDb() {
        return _dynamoDb2.apply(this, arguments);
      }

      _dynamoDb.toString = function () {
        return _dynamoDb2.toString();
      };

      return _dynamoDb;
    }(function () {
      return _classPrivateFieldGet(this, _dynamoDb).call(this);
    })
  }, {
    key: "generateDynamoTableKey",
    value: function generateDynamoTableKey() {
      return _generateDynamoTableKey();
    }
  }, {
    key: "_getLocalVariables",
    value: function _getLocalVariables() {
      return {
        partitionKeyFieldName: _classPrivateFieldGet(this, _partitionKeyFieldName),
        sortKeyFieldName: _classPrivateFieldGet(this, _sortKeyFieldName),
        segmentPartitionValue: _classPrivateFieldGet(this, _segmentPartitionValue),
        tableFullName: _classPrivateFieldGet(this, _tableFullName),
        secondaryIndexOptions: _classPrivateFieldGet(this, _secondaryIndexOptions)
      };
    }
  }, {
    key: "_getBaseObject",
    value: function _getBaseObject(_ref2) {
      var _dataMust;

      var dataId = _ref2.dataId;

      var _this$_getLocalVariab = this._getLocalVariables(),
          partitionKeyFieldName = _this$_getLocalVariab.partitionKeyFieldName,
          sortKeyFieldName = _this$_getLocalVariab.sortKeyFieldName,
          segmentPartitionValue = _this$_getLocalVariab.segmentPartitionValue;

      var dataMust = (_dataMust = {}, _defineProperty(_dataMust, partitionKeyFieldName, segmentPartitionValue), _defineProperty(_dataMust, sortKeyFieldName, dataId), _dataMust);
      return dataMust;
    }
  }, {
    key: "allCreateOneBase",
    value: function () {
      var _allCreateOneBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref3) {
        var data, _this$_getLocalVariab2, tableFullName, sortKeyFieldName, dataId, baseData, dataMust, fullData, _yield$this$_allHelpV, validatedData, marshalled, params, result;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                data = _ref3.data;
                _this$_getLocalVariab2 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab2.tableFullName, sortKeyFieldName = _this$_getLocalVariab2.sortKeyFieldName;
                dataId = data[sortKeyFieldName];

                if (!dataId) {
                  dataId = this.generateDynamoTableKey();
                }

                baseData = {
                  createdAtDate: new Date().toISOString()
                };
                dataMust = this._getBaseObject({
                  dataId: dataId
                });
                fullData = _objectSpread(_objectSpread(_objectSpread({}, data), baseData), dataMust);
                _context.next = 9;
                return this._allHelpValidateMarshallAndGetValue(fullData);

              case 9:
                _yield$this$_allHelpV = _context.sent;
                validatedData = _yield$this$_allHelpV.validatedData;
                marshalled = _yield$this$_allHelpV.marshalled;
                params = {
                  TableName: tableFullName,
                  Item: marshalled
                };
                _context.next = 15;
                return this._dynamoDb().putItem(params).promise();

              case 15:
                result = validatedData;
                return _context.abrupt("return", result);

              case 17:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function allCreateOneBase(_x) {
        return _allCreateOneBase.apply(this, arguments);
      }

      return allCreateOneBase;
    }()
  }, {
    key: "allGetOneByIdBase",
    value: function () {
      var _allGetOneByIdBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref4) {
        var _Key;

        var dataId, _this$_getLocalVariab3, partitionKeyFieldName, sortKeyFieldName, segmentPartitionValue, tableFullName, params, _data, data;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                dataId = _ref4.dataId;
                _this$_getLocalVariab3 = this._getLocalVariables(), partitionKeyFieldName = _this$_getLocalVariab3.partitionKeyFieldName, sortKeyFieldName = _this$_getLocalVariab3.sortKeyFieldName, segmentPartitionValue = _this$_getLocalVariab3.segmentPartitionValue, tableFullName = _this$_getLocalVariab3.tableFullName;
                this.allHelpValidateRequiredString({
                  QueryGetOnePartitionKey: segmentPartitionValue,
                  QueryGetOneSortKey: dataId
                });
                params = {
                  TableName: tableFullName,
                  Key: (_Key = {}, _defineProperty(_Key, partitionKeyFieldName, segmentPartitionValue), _defineProperty(_Key, sortKeyFieldName, dataId), _Key)
                };
                _context2.next = 6;
                return this._dynamoDbClient().get(params).promise();

              case 6:
                _data = _context2.sent;
                data = _data.Item;

                if (!data) {
                  _context2.next = 10;
                  break;
                }

                return _context2.abrupt("return", data);

              case 10:
                return _context2.abrupt("return", null);

              case 11:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function allGetOneByIdBase(_x2) {
        return _allGetOneByIdBase.apply(this, arguments);
      }

      return allGetOneByIdBase;
    }()
  }, {
    key: "allGetOneByIdProjectBase",
    value: function () {
      var _allGetOneByIdProjectBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(_ref5) {
        var _Key2;

        var dataId, projectionAttributes, _this$_getLocalVariab4, partitionKeyFieldName, sortKeyFieldName, segmentPartitionValue, tableFullName, params, _data, data;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                dataId = _ref5.dataId, projectionAttributes = _ref5.projectionAttributes;
                this.allHelpValidateRequiredString({
                  Get1DataId: dataId
                });
                _this$_getLocalVariab4 = this._getLocalVariables(), partitionKeyFieldName = _this$_getLocalVariab4.partitionKeyFieldName, sortKeyFieldName = _this$_getLocalVariab4.sortKeyFieldName, segmentPartitionValue = _this$_getLocalVariab4.segmentPartitionValue, tableFullName = _this$_getLocalVariab4.tableFullName;
                params = {
                  TableName: tableFullName,
                  Key: (_Key2 = {}, _defineProperty(_Key2, partitionKeyFieldName, segmentPartitionValue), _defineProperty(_Key2, sortKeyFieldName, dataId), _Key2),
                  ProjectionExpression: projectionAttributes.join(", ").trim()
                };
                _context3.next = 6;
                return this._dynamoDbClient().get(params).promise();

              case 6:
                _data = _context3.sent;
                data = _data.Item;
                return _context3.abrupt("return", data);

              case 9:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function allGetOneByIdProjectBase(_x3) {
        return _allGetOneByIdProjectBase.apply(this, arguments);
      }

      return allGetOneByIdProjectBase;
    }()
  }, {
    key: "allUpdateOneDirectBase",
    value: function () {
      var _allUpdateOneDirectBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(_ref6) {
        var data, _this$_getLocalVariab5, tableFullName, sortKeyFieldName, dataId, dataMust, baseData, fullData, _yield$this$_allHelpV2, validatedData, marshalled, params, result;

        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                data = _ref6.data;
                _this$_getLocalVariab5 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab5.tableFullName, sortKeyFieldName = _this$_getLocalVariab5.sortKeyFieldName;
                dataId = data[sortKeyFieldName];

                if (dataId) {
                  _context4.next = 5;
                  break;
                }

                throw new _errors.GenericDataError("Update data requires sort key field value");

              case 5:
                dataMust = this._getBaseObject({
                  dataId: dataId
                });
                baseData = {
                  lastModifiedDate: new Date().toISOString()
                };
                fullData = _objectSpread(_objectSpread(_objectSpread({}, data), baseData), dataMust); //

                _context4.next = 10;
                return this._allHelpValidateMarshallAndGetValue(fullData);

              case 10:
                _yield$this$_allHelpV2 = _context4.sent;
                validatedData = _yield$this$_allHelpV2.validatedData;
                marshalled = _yield$this$_allHelpV2.marshalled;
                params = {
                  TableName: tableFullName,
                  Item: marshalled
                };
                _context4.next = 16;
                return this._dynamoDb().putItem(params).promise();

              case 16:
                result = validatedData;
                return _context4.abrupt("return", result);

              case 18:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function allUpdateOneDirectBase(_x4) {
        return _allUpdateOneDirectBase.apply(this, arguments);
      }

      return allUpdateOneDirectBase;
    }()
  }, {
    key: "allUpdateOneByIdBase",
    value: function () {
      var _allUpdateOneByIdBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(_ref7) {
        var dataId, data, _this$_getLocalVariab6, tableFullName, sortKeyFieldName, dataInDb, dataMust, fullData, _yield$this$_allHelpV3, validatedData, marshalled, params, result;

        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                dataId = _ref7.dataId, data = _ref7.data;
                _this$_getLocalVariab6 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab6.tableFullName, sortKeyFieldName = _this$_getLocalVariab6.sortKeyFieldName;
                this.allHelpValidateRequiredString({
                  Update1DataId: dataId
                });
                _context5.next = 5;
                return this.allGetOneByIdBase({
                  dataId: dataId
                });

              case 5:
                dataInDb = _context5.sent;

                if (dataInDb && dataInDb[sortKeyFieldName]) {
                  _context5.next = 8;
                  break;
                }

                throw new _errors.GenericDataError("Data does NOT exists");

              case 8:
                dataMust = this._getBaseObject({
                  dataId: dataInDb[sortKeyFieldName]
                });
                fullData = _objectSpread(_objectSpread(_objectSpread({}, dataInDb), data), dataMust);
                _context5.next = 12;
                return this._allHelpValidateMarshallAndGetValue(fullData);

              case 12:
                _yield$this$_allHelpV3 = _context5.sent;
                validatedData = _yield$this$_allHelpV3.validatedData;
                marshalled = _yield$this$_allHelpV3.marshalled;
                params = {
                  TableName: tableFullName,
                  Item: marshalled
                };
                _context5.next = 18;
                return this._dynamoDb().putItem(params).promise();

              case 18:
                result = validatedData;
                return _context5.abrupt("return", result);

              case 20:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function allUpdateOneByIdBase(_x5) {
        return _allUpdateOneByIdBase.apply(this, arguments);
      }

      return allUpdateOneByIdBase;
    }()
  }, {
    key: "_allHelpValidateMarshallAndGetValue",
    value: function () {
      var _allHelpValidateMarshallAndGetValue2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(data) {
        var _classPrivateFieldGet2, error, value, marshalledData;

        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _classPrivateFieldGet2 = _classPrivateFieldGet(this, _schema).validate(data, {
                  stripUnknown: true
                }), error = _classPrivateFieldGet2.error, value = _classPrivateFieldGet2.value;

                if (!error) {
                  _context6.next = 6;
                  break;
                }

                _loggingService.LoggingService.log({
                  "@JoiValidate": "",
                  error: error,
                  value: value
                });

                _context6.next = 5;
                return Promise.reject((0, _baseJoiHelper.getJoiValidationErrors)(error));

              case 5:
                return _context6.abrupt("return", _context6.sent);

              case 6:
                marshalledData = _classPrivateFieldGet(this, _marshaller).marshallItem(value);
                return _context6.abrupt("return", {
                  validatedData: value,
                  marshalled: marshalledData
                });

              case 8:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function _allHelpValidateMarshallAndGetValue(_x6) {
        return _allHelpValidateMarshallAndGetValue2.apply(this, arguments);
      }

      return _allHelpValidateMarshallAndGetValue;
    }() //================================

  }, {
    key: "allGetListOfTablesNamesOnlineBase",
    value: function () {
      var _allGetListOfTablesNamesOnlineBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
        var params, listOfTables;
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                params = {
                  Limit: 99
                };
                _context7.next = 3;
                return this._dynamoDb().listTables(params).promise();

              case 3:
                listOfTables = _context7.sent;
                return _context7.abrupt("return", listOfTables === null || listOfTables === void 0 ? void 0 : listOfTables.TableNames);

              case 5:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function allGetListOfTablesNamesOnlineBase() {
        return _allGetListOfTablesNamesOnlineBase.apply(this, arguments);
      }

      return allGetListOfTablesNamesOnlineBase;
    }()
  }, {
    key: "allTableSettingUpdateTTLBase",
    value: function () {
      var _allTableSettingUpdateTTLBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(_ref8) {
        var attrName, isEnabled, _this$_getLocalVariab7, tableFullName, params, result;

        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                attrName = _ref8.attrName, isEnabled = _ref8.isEnabled;
                _this$_getLocalVariab7 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab7.tableFullName;
                params = {
                  TableName: tableFullName,
                  TimeToLiveSpecification: {
                    AttributeName: attrName,
                    Enabled: isEnabled
                  }
                };
                _context8.next = 5;
                return this._dynamoDb().updateTimeToLive(params).promise();

              case 5:
                result = _context8.sent;

                if (!(result === null || result === void 0 ? void 0 : result.TimeToLiveSpecification)) {
                  _context8.next = 8;
                  break;
                }

                return _context8.abrupt("return", result.TimeToLiveSpecification);

              case 8:
                return _context8.abrupt("return", null);

              case 9:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function allTableSettingUpdateTTLBase(_x7) {
        return _allTableSettingUpdateTTLBase.apply(this, arguments);
      }

      return allTableSettingUpdateTTLBase;
    }()
  }, {
    key: "allGetTableInfoBase",
    value: function () {
      var _allGetTableInfoBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
        var _result$Table, _this$_getLocalVariab8, tableFullName, params, result;

        return regeneratorRuntime.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.prev = 0;
                _this$_getLocalVariab8 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab8.tableFullName;
                params = {
                  TableName: tableFullName
                };
                _context9.next = 5;
                return this._dynamoDb().describeTable(params).promise();

              case 5:
                result = _context9.sent;

                if (!((result === null || result === void 0 ? void 0 : (_result$Table = result.Table) === null || _result$Table === void 0 ? void 0 : _result$Table.TableName) === tableFullName)) {
                  _context9.next = 8;
                  break;
                }

                return _context9.abrupt("return", result.Table);

              case 8:
                return _context9.abrupt("return", null);

              case 11:
                _context9.prev = 11;
                _context9.t0 = _context9["catch"](0);

                _loggingService.LoggingService.log({
                  "@allGetTableInfoBase": "",
                  error: _context9.t0 === null || _context9.t0 === void 0 ? void 0 : _context9.t0.message
                });

                return _context9.abrupt("return", null);

              case 15:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this, [[0, 11]]);
      }));

      function allGetTableInfoBase() {
        return _allGetTableInfoBase.apply(this, arguments);
      }

      return allGetTableInfoBase;
    }()
  }, {
    key: "allCheckTableExistsBase",
    value: function () {
      var _allCheckTableExistsBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10() {
        var result;
        return regeneratorRuntime.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _context10.next = 2;
                return this.allGetTableInfoBase();

              case 2:
                result = _context10.sent;

                if (result) {
                  _context10.next = 5;
                  break;
                }

                return _context10.abrupt("return", false);

              case 5:
                if (result === null || result === void 0 ? void 0 : result.GlobalSecondaryIndexes) {// console.log(JSON.stringify({ tableInfo: result }, null, 2));
                }

                return _context10.abrupt("return", true);

              case 7:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function allCheckTableExistsBase() {
        return _allCheckTableExistsBase.apply(this, arguments);
      }

      return allCheckTableExistsBase;
    }()
  }, {
    key: "allCreateTableIfNotExistsBase",
    value: function () {
      var _allCreateTableIfNotExistsBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11() {
        var _this$_getLocalVariab9, secondaryIndexOptions, existingTableInfo, _existingTableInfo$Gl;

        return regeneratorRuntime.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _this$_getLocalVariab9 = this._getLocalVariables(), secondaryIndexOptions = _this$_getLocalVariab9.secondaryIndexOptions;
                _context11.prev = 1;
                _context11.next = 4;
                return this.allGetTableInfoBase();

              case 4:
                existingTableInfo = _context11.sent;
                console.log({
                  existingTableInfo: existingTableInfo
                });

                if (!existingTableInfo) {
                  _context11.next = 16;
                  break;
                }

                if (!(secondaryIndexOptions === null || secondaryIndexOptions === void 0 ? void 0 : secondaryIndexOptions.length)) {
                  _context11.next = 12;
                  break;
                }

                _context11.next = 10;
                return this._allUpdateGlobalSecondaryIndexBase({
                  secondaryIndexOptions: secondaryIndexOptions,
                  existingTableInfo: existingTableInfo
                });

              case 10:
                _context11.next = 15;
                break;

              case 12:
                if (!((_existingTableInfo$Gl = existingTableInfo.GlobalSecondaryIndexes) === null || _existingTableInfo$Gl === void 0 ? void 0 : _existingTableInfo$Gl.length)) {
                  _context11.next = 15;
                  break;
                }

                _context11.next = 15;
                return this._allUpdateGlobalSecondaryIndexBase({
                  secondaryIndexOptions: [],
                  existingTableInfo: existingTableInfo
                });

              case 15:
                return _context11.abrupt("return", null);

              case 16:
                _context11.next = 20;
                break;

              case 18:
                _context11.prev = 18;
                _context11.t0 = _context11["catch"](1);

              case 20:
                _context11.next = 22;
                return this.allCreateTableBase();

              case 22:
                return _context11.abrupt("return", _context11.sent);

              case 23:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this, [[1, 18]]);
      }));

      function allCreateTableIfNotExistsBase() {
        return _allCreateTableIfNotExistsBase.apply(this, arguments);
      }

      return allCreateTableIfNotExistsBase;
    }()
  }, {
    key: "allCreateTableBase",
    value: function () {
      var _allCreateTableBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12() {
        var _this$_getLocalVariab10, partitionKeyFieldName, sortKeyFieldName, tableFullName, secondaryIndexOptions, params, _creationParams$xAttr, creationParams, existAttrDefNames, result;

        return regeneratorRuntime.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _this$_getLocalVariab10 = this._getLocalVariables(), partitionKeyFieldName = _this$_getLocalVariab10.partitionKeyFieldName, sortKeyFieldName = _this$_getLocalVariab10.sortKeyFieldName, tableFullName = _this$_getLocalVariab10.tableFullName, secondaryIndexOptions = _this$_getLocalVariab10.secondaryIndexOptions;
                params = {
                  AttributeDefinitions: [{
                    AttributeName: partitionKeyFieldName,
                    AttributeType: "S"
                  }, {
                    AttributeName: sortKeyFieldName,
                    AttributeType: "S"
                  }],
                  KeySchema: [{
                    AttributeName: partitionKeyFieldName,
                    KeyType: "HASH"
                  }, {
                    AttributeName: sortKeyFieldName,
                    KeyType: "RANGE"
                  }],
                  BillingMode: "PAY_PER_REQUEST",
                  TableName: tableFullName
                };
                params.Tags = [{
                  Key: "tablePrefix",
                  Value: tableFullName
                }, {
                  Key: "DDBTableGroupKey-".concat(tableFullName),
                  Value: tableFullName
                }];

                if (secondaryIndexOptions === null || secondaryIndexOptions === void 0 ? void 0 : secondaryIndexOptions.length) {
                  creationParams = this._getGlobalSecondaryIndexCreationParams(secondaryIndexOptions);

                  if ((_creationParams$xAttr = creationParams.xAttributeDefinitions) === null || _creationParams$xAttr === void 0 ? void 0 : _creationParams$xAttr.length) {
                    existAttrDefNames = params.AttributeDefinitions.map(function (def) {
                      return def.AttributeName;
                    });
                    creationParams.xAttributeDefinitions.forEach(function (def) {
                      var alreadyDefined = existAttrDefNames.includes(def.AttributeName);

                      if (!alreadyDefined) {
                        params.AttributeDefinitions.push(def);
                      }
                    });
                  }

                  params.GlobalSecondaryIndexes = _toConsumableArray(creationParams.xGlobalSecondaryIndex);
                }

                _loggingService.LoggingService.log({
                  "@allCreateTableBase, table: ": tableFullName
                });

                _context12.next = 7;
                return this._dynamoDb().createTable(params).promise();

              case 7:
                result = _context12.sent;

                if (!(result === null || result === void 0 ? void 0 : result.TableDescription)) {
                  _context12.next = 11;
                  break;
                }

                _loggingService.LoggingService.log(["@allCreateTableBase,", "Created table: '".concat(result === null || result === void 0 ? void 0 : result.TableDescription.TableName, "'"), new Date().toTimeString()].join(" "));

                return _context12.abrupt("return", result.TableDescription);

              case 11:
                return _context12.abrupt("return", null);

              case 12:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function allCreateTableBase() {
        return _allCreateTableBase.apply(this, arguments);
      }

      return allCreateTableBase;
    }()
  }, {
    key: "allDeleteGlobalSecondaryIndexBase",
    value: function () {
      var _allDeleteGlobalSecondaryIndexBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13(indexName) {
        var _this$_getLocalVariab11, tableFullName, params, result;

        return regeneratorRuntime.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                _this$_getLocalVariab11 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab11.tableFullName;
                params = {
                  TableName: tableFullName,
                  GlobalSecondaryIndexUpdates: [{
                    Delete: {
                      IndexName: indexName
                    }
                  }]
                };
                _context13.next = 4;
                return this._dynamoDb().updateTable(params).promise();

              case 4:
                result = _context13.sent;

                if (!(result === null || result === void 0 ? void 0 : result.TableDescription)) {
                  _context13.next = 7;
                  break;
                }

                return _context13.abrupt("return", result.TableDescription);

              case 7:
                return _context13.abrupt("return", null);

              case 8:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function allDeleteGlobalSecondaryIndexBase(_x8) {
        return _allDeleteGlobalSecondaryIndexBase.apply(this, arguments);
      }

      return allDeleteGlobalSecondaryIndexBase;
    }()
  }, {
    key: "allExistsByIdBase",
    value: function () {
      var _allExistsByIdBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee14(dataId) {
        var _this$_getLocalVariab12, sortKeyFieldName, data;

        return regeneratorRuntime.wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                this.allHelpValidateRequiredString({
                  Exist1DataId: dataId
                });
                _this$_getLocalVariab12 = this._getLocalVariables(), sortKeyFieldName = _this$_getLocalVariab12.sortKeyFieldName;
                _context14.next = 4;
                return this.allGetOneByIdProjectBase({
                  dataId: dataId,
                  projectionAttributes: [sortKeyFieldName]
                });

              case 4:
                data = _context14.sent;

                if (!(data && data[sortKeyFieldName])) {
                  _context14.next = 7;
                  break;
                }

                return _context14.abrupt("return", true);

              case 7:
                return _context14.abrupt("return", false);

              case 8:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function allExistsByIdBase(_x9) {
        return _allExistsByIdBase.apply(this, arguments);
      }

      return allExistsByIdBase;
    }()
  }, {
    key: "_getGlobalSecondaryIndexCreationParams",
    value: function _getGlobalSecondaryIndexCreationParams(secondaryIndexOptions) {
      var _this$_getLocalVariab13 = this._getLocalVariables(),
          tableFullName = _this$_getLocalVariab13.tableFullName;

      var params = {
        KeySchema: [],
        //  make linter happy
        AttributeDefinitions: [],
        TableName: tableFullName,
        GlobalSecondaryIndexes: []
      };
      var attributeDefinitionsNameList = [];
      secondaryIndexOptions.forEach(function (sIndex) {
        var _projectionFields, _params$GlobalSeconda;

        var indexName = sIndex.indexName,
            keyFieldName = sIndex.keyFieldName,
            sortFieldName = sIndex.sortFieldName,
            dataType = sIndex.dataType,
            projectionFieldsInclude = sIndex.projectionFieldsInclude; //

        var _keyFieldName = keyFieldName;
        var _sortFieldName = sortFieldName;

        if (!attributeDefinitionsNameList.includes(_keyFieldName)) {
          var _params$AttributeDefi;

          attributeDefinitionsNameList.push(_keyFieldName);
          params === null || params === void 0 ? void 0 : (_params$AttributeDefi = params.AttributeDefinitions) === null || _params$AttributeDefi === void 0 ? void 0 : _params$AttributeDefi.push({
            AttributeName: _keyFieldName,
            AttributeType: dataType
          });
        }

        if (!attributeDefinitionsNameList.includes(_sortFieldName)) {
          var _params$AttributeDefi2;

          attributeDefinitionsNameList.push(_sortFieldName);
          params === null || params === void 0 ? void 0 : (_params$AttributeDefi2 = params.AttributeDefinitions) === null || _params$AttributeDefi2 === void 0 ? void 0 : _params$AttributeDefi2.push({
            AttributeName: _sortFieldName,
            AttributeType: dataType
          });
        }

        var projectionFields = projectionFieldsInclude || [];
        var projectionType = "ALL";

        if ((_projectionFields = projectionFields) === null || _projectionFields === void 0 ? void 0 : _projectionFields.length) {
          // remove frimary keys from include
          projectionFields = projectionFields.filter(function (field) {
            return field !== _keyFieldName && field !== _sortFieldName;
          });

          if (projectionFields.length === 0) {
            // only keys was projceted
            projectionType = "KEYS_ONLY";
          } else {
            // only keys was projceted
            projectionType = "INCLUDE";
          }
        }

        (_params$GlobalSeconda = params.GlobalSecondaryIndexes) === null || _params$GlobalSeconda === void 0 ? void 0 : _params$GlobalSeconda.push({
          IndexName: indexName,
          Projection: {
            ProjectionType: projectionType,
            NonKeyAttributes: projectionType === "INCLUDE" ? projectionFields : undefined
          },
          KeySchema: [{
            AttributeName: _keyFieldName,
            KeyType: "HASH"
          }, {
            AttributeName: _sortFieldName,
            KeyType: "RANGE"
          }]
        });
      });
      return {
        xAttributeDefinitions: params.AttributeDefinitions || [],
        xGlobalSecondaryIndex: params.GlobalSecondaryIndexes || []
      };
    }
  }, {
    key: "_allUpdateGlobalSecondaryIndexBase",
    value: function () {
      var _allUpdateGlobalSecondaryIndexBase2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee15(_ref9) {
        var _this2 = this;

        var secondaryIndexOptions, existingTableInfo, _existingTableInfo$Gl2, existingIndexNames, staledIndexNames, allIndexNames, newSecondaryIndexOptions, updateResults, canUpdate, _this$_getLocalVariab14, tableFullName, indexCount, _iterator, _step, _loop, _indexCount, _iterator2, _step2, _params$GlobalSeconda3, indexName, params, result, label;

        return regeneratorRuntime.wrap(function _callee15$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                secondaryIndexOptions = _ref9.secondaryIndexOptions, existingTableInfo = _ref9.existingTableInfo;
                _context16.prev = 1;
                existingIndexNames = [];
                staledIndexNames = [];
                allIndexNames = [];
                newSecondaryIndexOptions = [];
                updateResults = [];

                if (existingTableInfo === null || existingTableInfo === void 0 ? void 0 : (_existingTableInfo$Gl2 = existingTableInfo.GlobalSecondaryIndexes) === null || _existingTableInfo$Gl2 === void 0 ? void 0 : _existingTableInfo$Gl2.length) {
                  existingTableInfo === null || existingTableInfo === void 0 ? void 0 : existingTableInfo.GlobalSecondaryIndexes.forEach(function (indexInfo) {
                    if (indexInfo.IndexName) {
                      existingIndexNames.push(indexInfo.IndexName);
                    }
                  });
                }

                secondaryIndexOptions === null || secondaryIndexOptions === void 0 ? void 0 : secondaryIndexOptions.forEach(function (newIndexInfo) {
                  allIndexNames.push(newIndexInfo.indexName);
                  var indexExists = existingIndexNames.includes(newIndexInfo.indexName);

                  if (!indexExists) {
                    newSecondaryIndexOptions.push(newIndexInfo);
                  }
                });
                existingIndexNames.forEach(function (indexName) {
                  var existsInList = allIndexNames.includes(indexName);

                  if (!existsInList) {
                    staledIndexNames.push(indexName);
                  }
                });

                if (newSecondaryIndexOptions.length || staledIndexNames.length) {
                  _context16.next = 12;
                  break;
                }

                return _context16.abrupt("return", null);

              case 12:
                canUpdate = false;
                _this$_getLocalVariab14 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab14.tableFullName;

                _loggingService.LoggingService.log({
                  secondaryIndexOptions: secondaryIndexOptions.length,
                  newSecondaryIndexOptions: newSecondaryIndexOptions.length,
                  staledIndexNames: staledIndexNames.length,
                  tableName: tableFullName
                });

                if (!newSecondaryIndexOptions.length) {
                  _context16.next = 34;
                  break;
                }

                canUpdate = true;
                indexCount = 0;
                _iterator = _createForOfIteratorHelper(newSecondaryIndexOptions);
                _context16.prev = 19;
                _loop = /*#__PURE__*/regeneratorRuntime.mark(function _loop() {
                  var indexOption, params, creationParams, indexName, result, label;
                  return regeneratorRuntime.wrap(function _loop$(_context15) {
                    while (1) {
                      switch (_context15.prev = _context15.next) {
                        case 0:
                          indexOption = _step.value;
                          params = {
                            TableName: tableFullName,
                            GlobalSecondaryIndexUpdates: []
                          };
                          indexCount++;
                          creationParams = _this2._getGlobalSecondaryIndexCreationParams([indexOption]);
                          indexName = creationParams.xGlobalSecondaryIndex[0].IndexName;
                          params.AttributeDefinitions = _toConsumableArray(creationParams.xAttributeDefinitions);
                          creationParams.xGlobalSecondaryIndex.forEach(function (gsi) {
                            var _params$GlobalSeconda2;

                            (_params$GlobalSeconda2 = params.GlobalSecondaryIndexUpdates) === null || _params$GlobalSeconda2 === void 0 ? void 0 : _params$GlobalSeconda2.push({
                              Create: _objectSpread({}, gsi)
                            });
                          });
                          _context15.next = 9;
                          return _this2._dynamoDb().updateTable(params).promise();

                        case 9:
                          result = _context15.sent;

                          if (result === null || result === void 0 ? void 0 : result.TableDescription) {
                            updateResults.push(result === null || result === void 0 ? void 0 : result.TableDescription);
                          }

                          _loggingService.LoggingService.log(["Creating Index: '".concat(indexName, "'"), "on table '".concat(tableFullName, "' started:"), new Date().toTimeString()].join(" "));

                          if (!(indexCount !== newSecondaryIndexOptions.length)) {
                            _context15.next = 18;
                            break;
                          }

                          label = "Created Index '".concat(indexName, "'");
                          console.time(label);
                          _context15.next = 17;
                          return _utilService.UtilService.waitUntilMunites(5);

                        case 17:
                          console.timeEnd(label);

                        case 18:
                        case "end":
                          return _context15.stop();
                      }
                    }
                  }, _loop);
                });

                _iterator.s();

              case 22:
                if ((_step = _iterator.n()).done) {
                  _context16.next = 26;
                  break;
                }

                return _context16.delegateYield(_loop(), "t0", 24);

              case 24:
                _context16.next = 22;
                break;

              case 26:
                _context16.next = 31;
                break;

              case 28:
                _context16.prev = 28;
                _context16.t1 = _context16["catch"](19);

                _iterator.e(_context16.t1);

              case 31:
                _context16.prev = 31;

                _iterator.f();

                return _context16.finish(31);

              case 34:
                if (!staledIndexNames.length) {
                  _context16.next = 69;
                  break;
                }

                if (!canUpdate) {
                  _context16.next = 38;
                  break;
                }

                _context16.next = 38;
                return _utilService.UtilService.waitUntilMunites(4);

              case 38:
                canUpdate = true;
                _indexCount = 0;
                _iterator2 = _createForOfIteratorHelper(staledIndexNames);
                _context16.prev = 41;

                _iterator2.s();

              case 43:
                if ((_step2 = _iterator2.n()).done) {
                  _context16.next = 61;
                  break;
                }

                indexName = _step2.value;
                params = {
                  TableName: tableFullName,
                  GlobalSecondaryIndexUpdates: []
                };
                _indexCount++;
                (_params$GlobalSeconda3 = params.GlobalSecondaryIndexUpdates) === null || _params$GlobalSeconda3 === void 0 ? void 0 : _params$GlobalSeconda3.push({
                  Delete: {
                    IndexName: indexName
                  }
                });
                _context16.next = 50;
                return this._dynamoDb().updateTable(params).promise();

              case 50:
                result = _context16.sent;

                if (result === null || result === void 0 ? void 0 : result.TableDescription) {
                  updateResults.push(result === null || result === void 0 ? void 0 : result.TableDescription);
                }

                _loggingService.LoggingService.log(["Deleting Index: '".concat(indexName, "'"), "on table '".concat(tableFullName, "' started:"), new Date().toTimeString()].join(" "));

                if (!(_indexCount !== staledIndexNames.length)) {
                  _context16.next = 59;
                  break;
                }

                label = "Deleted Index '".concat(indexName, "'");
                console.time(label);
                _context16.next = 58;
                return _utilService.UtilService.waitUntilMunites(1);

              case 58:
                console.timeEnd(label);

              case 59:
                _context16.next = 43;
                break;

              case 61:
                _context16.next = 66;
                break;

              case 63:
                _context16.prev = 63;
                _context16.t2 = _context16["catch"](41);

                _iterator2.e(_context16.t2);

              case 66:
                _context16.prev = 66;

                _iterator2.f();

                return _context16.finish(66);

              case 69:
                if (canUpdate) {
                  _context16.next = 71;
                  break;
                }

                return _context16.abrupt("return", null);

              case 71:
                if (!updateResults.length) {
                  _context16.next = 74;
                  break;
                }

                console.log({
                  "@allCreateGlobalSecondaryIndexBase": "",
                  updateResults: updateResults
                });
                return _context16.abrupt("return", updateResults);

              case 74:
                return _context16.abrupt("return", null);

              case 77:
                _context16.prev = 77;
                _context16.t3 = _context16["catch"](1);

                _loggingService.LoggingService.log({
                  "@allCreateGlobalSecondaryIndexBase": "",
                  error: _context16.t3 === null || _context16.t3 === void 0 ? void 0 : _context16.t3.message
                });

                return _context16.abrupt("return", null);

              case 81:
              case "end":
                return _context16.stop();
            }
          }
        }, _callee15, this, [[1, 77], [19, 28, 31, 34], [41, 63, 66, 69]]);
      }));

      function _allUpdateGlobalSecondaryIndexBase(_x10) {
        return _allUpdateGlobalSecondaryIndexBase2.apply(this, arguments);
      }

      return _allUpdateGlobalSecondaryIndexBase;
    }()
  }, {
    key: "allQueryBySecondaryIndexBase",
    value: function () {
      var _allQueryBySecondaryIndexBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee16(_ref10) {
        var _ref10$keyQueryEquals, keyFieldName, value, secondaryIndexName, orderDesc, sortKeyQueryOptions, result;

        return regeneratorRuntime.wrap(function _callee16$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                _ref10$keyQueryEquals = _ref10.keyQueryEquals, keyFieldName = _ref10$keyQueryEquals.keyFieldName, value = _ref10$keyQueryEquals.value, secondaryIndexName = _ref10.secondaryIndexName, orderDesc = _ref10.orderDesc, sortKeyQueryOptions = _ref10.sortKeyQueryOptions;
                _context17.next = 3;
                return this.allQueryBySecondaryIndexPaginateBase({
                  keyQueryEquals: {
                    keyFieldName: keyFieldName,
                    value: value
                  },
                  secondaryIndexName: secondaryIndexName,
                  orderDesc: orderDesc,
                  sortKeyQueryOptions: sortKeyQueryOptions
                });

              case 3:
                result = _context17.sent;

                if (!(result === null || result === void 0 ? void 0 : result.mainResult)) {
                  _context17.next = 6;
                  break;
                }

                return _context17.abrupt("return", result.mainResult);

              case 6:
                return _context17.abrupt("return", []);

              case 7:
              case "end":
                return _context17.stop();
            }
          }
        }, _callee16, this);
      }));

      function allQueryBySecondaryIndexBase(_x11) {
        return _allQueryBySecondaryIndexBase.apply(this, arguments);
      }

      return allQueryBySecondaryIndexBase;
    }()
  }, {
    key: "allQueryGetManyByConditionBase",
    value: function () {
      var _allQueryGetManyByConditionBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee17(paramOptions) {
        var _result$mainResult;

        var result;
        return regeneratorRuntime.wrap(function _callee17$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                paramOptions.pagingParams = undefined;
                _context18.next = 3;
                return this.allQueryGetManyByConditionPaginateBase(paramOptions);

              case 3:
                result = _context18.sent;

                if (!(result === null || result === void 0 ? void 0 : (_result$mainResult = result.mainResult) === null || _result$mainResult === void 0 ? void 0 : _result$mainResult.length)) {
                  _context18.next = 6;
                  break;
                }

                return _context18.abrupt("return", result.mainResult);

              case 6:
                return _context18.abrupt("return", []);

              case 7:
              case "end":
                return _context18.stop();
            }
          }
        }, _callee17, this);
      }));

      function allQueryGetManyByConditionBase(_x12) {
        return _allQueryGetManyByConditionBase.apply(this, arguments);
      }

      return allQueryGetManyByConditionBase;
    }()
  }, {
    key: "allQueryGetManyByConditionPaginateBase",
    value: function () {
      var _allQueryGetManyByConditionPaginateBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee18(paramOptions) {
        var _paramOptions$partiti, _paramOptions$fields, _otherFilterExpressio, _paramOptions$pagingP;

        var _this$_getLocalVariab15, tableFullName, sortKeyFieldName, partitionKeyFieldName, sortKeyQuery, sortKeyQueryData, filterHashSortKey, otherFilterExpression, otherExpressionAttributeValues, otherExpressionAttributeNames, filterOtherAttributes, params, hashKeyAndSortKey, paginationObjects, result;

        return regeneratorRuntime.wrap(function _callee18$(_context19) {
          while (1) {
            switch (_context19.prev = _context19.next) {
              case 0:
                _this$_getLocalVariab15 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab15.tableFullName, sortKeyFieldName = _this$_getLocalVariab15.sortKeyFieldName, partitionKeyFieldName = _this$_getLocalVariab15.partitionKeyFieldName; //

                if (paramOptions === null || paramOptions === void 0 ? void 0 : (_paramOptions$partiti = paramOptions.partitionSortKeyQuery) === null || _paramOptions$partiti === void 0 ? void 0 : _paramOptions$partiti.partitionKeyEquals) {
                  _context19.next = 3;
                  break;
                }

                throw new _errors.GenericDataError("Invalid Hash key value");

              case 3:
                if (sortKeyFieldName) {
                  _context19.next = 5;
                  break;
                }

                throw new _errors.GenericDataError("Bad query sort configuration");

              case 5:
                sortKeyQuery = {};
                sortKeyQueryData = paramOptions.partitionSortKeyQuery.sortKeyQuery;

                if (!sortKeyQueryData) {
                  _context19.next = 13;
                  break;
                }

                if (!sortKeyQueryData[sortKeyFieldName]) {
                  _context19.next = 12;
                  break;
                }

                sortKeyQuery = _defineProperty({}, sortKeyFieldName, sortKeyQueryData[sortKeyFieldName]);
                _context19.next = 13;
                break;

              case 12:
                throw new _errors.GenericDataError("Invalid Sort key value");

              case 13:
                filterHashSortKey = this.__helperDynamoFilterOperation({
                  queryDefs: _objectSpread(_objectSpread({}, sortKeyQuery), _defineProperty({}, partitionKeyFieldName, paramOptions.partitionSortKeyQuery.partitionKeyEquals)),
                  projectionFields: (_paramOptions$fields = paramOptions === null || paramOptions === void 0 ? void 0 : paramOptions.fields) !== null && _paramOptions$fields !== void 0 ? _paramOptions$fields : undefined
                }); //
                //

                otherFilterExpression = undefined;
                otherExpressionAttributeValues = undefined;
                otherExpressionAttributeNames = undefined;

                if (paramOptions === null || paramOptions === void 0 ? void 0 : paramOptions.query) {
                  filterOtherAttributes = this.__helperDynamoFilterOperation({
                    queryDefs: paramOptions.query,
                    projectionFields: null
                  });
                  otherExpressionAttributeValues = filterOtherAttributes.expressionAttributeValues;
                  otherExpressionAttributeNames = filterOtherAttributes.expressionAttributeNames;

                  if ((filterOtherAttributes === null || filterOtherAttributes === void 0 ? void 0 : filterOtherAttributes.filterExpression) && (filterOtherAttributes === null || filterOtherAttributes === void 0 ? void 0 : filterOtherAttributes.filterExpression.length) > 1) {
                    otherFilterExpression = filterOtherAttributes.filterExpression;
                  }
                }

                params = {
                  TableName: tableFullName,
                  KeyConditionExpression: filterHashSortKey.filterExpression,
                  ExpressionAttributeValues: _objectSpread(_objectSpread({}, otherExpressionAttributeValues), filterHashSortKey.expressionAttributeValues),
                  FilterExpression: (_otherFilterExpressio = otherFilterExpression) !== null && _otherFilterExpressio !== void 0 ? _otherFilterExpressio : undefined,
                  ExpressionAttributeNames: _objectSpread(_objectSpread({}, otherExpressionAttributeNames), filterHashSortKey.expressionAttributeNames)
                };

                if (filterHashSortKey === null || filterHashSortKey === void 0 ? void 0 : filterHashSortKey.projectionExpressionAttr) {
                  params.ProjectionExpression = filterHashSortKey.projectionExpressionAttr;
                }

                if ((paramOptions === null || paramOptions === void 0 ? void 0 : (_paramOptions$pagingP = paramOptions.pagingParams) === null || _paramOptions$pagingP === void 0 ? void 0 : _paramOptions$pagingP.orderDesc) === true) {
                  params.ScanIndexForward = false;
                }

                hashKeyAndSortKey = [partitionKeyFieldName, sortKeyFieldName];
                paginationObjects = _objectSpread({}, paramOptions.pagingParams);
                _context19.next = 25;
                return this.__helperDynamoQueryProcessor(_objectSpread({
                  params: params,
                  hashKeyAndSortKey: hashKeyAndSortKey
                }, paginationObjects));

              case 25:
                result = _context19.sent;
                return _context19.abrupt("return", result);

              case 27:
              case "end":
                return _context19.stop();
            }
          }
        }, _callee18, this);
      }));

      function allQueryGetManyByConditionPaginateBase(_x13) {
        return _allQueryGetManyByConditionPaginateBase.apply(this, arguments);
      }

      return allQueryGetManyByConditionPaginateBase;
    }()
  }, {
    key: "allBatchGetManyByHashAndSortKey",
    value: function () {
      var _allBatchGetManyByHashAndSortKey = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee19(_ref11) {
        var _this3 = this;

        var dataIds, fields;
        return regeneratorRuntime.wrap(function _callee19$(_context20) {
          while (1) {
            switch (_context20.prev = _context20.next) {
              case 0:
                dataIds = _ref11.dataIds, fields = _ref11.fields;
                dataIds.forEach(function (sortKeyValue) {
                  _this3.allHelpValidateRequiredString({
                    BatchGetSortKey: sortKeyValue
                  });
                });
                return _context20.abrupt("return", new Promise(function (resolve, reject) {
                  var _this3$_getLocalVaria = _this3._getLocalVariables(),
                      tableFullName = _this3$_getLocalVaria.tableFullName,
                      partitionKeyFieldName = _this3$_getLocalVaria.partitionKeyFieldName,
                      sortKeyFieldName = _this3$_getLocalVaria.sortKeyFieldName,
                      segmentPartitionValue = _this3$_getLocalVaria.segmentPartitionValue;

                  var getArray = dataIds.map(function (sortKeyValue) {
                    var _params2;

                    var params01 = (_params2 = {}, _defineProperty(_params2, partitionKeyFieldName, {
                      S: segmentPartitionValue
                    }), _defineProperty(_params2, sortKeyFieldName, {
                      S: sortKeyValue
                    }), _params2);
                    return params01;
                  });
                  var projectionExpression = undefined;
                  var expressionAttributeNames = undefined;

                  if (fields === null || fields === void 0 ? void 0 : fields.length) {
                    var _Object$keys;

                    var _fields = _toConsumableArray(fields);

                    expressionAttributeNames = {};

                    _fields.forEach(function (fieldName) {
                      if (typeof fieldName === "string") {
                        if (expressionAttributeNames) {
                          var attrKeyHash = "#attrKey".concat(getRandom(), "k").toLowerCase();
                          expressionAttributeNames[attrKeyHash] = fieldName;
                        }
                      }
                    });

                    if ((_Object$keys = Object.keys(expressionAttributeNames)) === null || _Object$keys === void 0 ? void 0 : _Object$keys.length) {
                      projectionExpression = Object.keys(expressionAttributeNames).join(",");
                    } else {
                      projectionExpression = undefined;
                      expressionAttributeNames = undefined;
                    }
                  }

                  var params = {
                    RequestItems: _defineProperty({}, tableFullName, {
                      Keys: _toConsumableArray(getArray),
                      ConsistentRead: true,
                      ProjectionExpression: projectionExpression,
                      ExpressionAttributeNames: expressionAttributeNames
                    })
                  };
                  var returnedItems = [];

                  var batchGetUntilDone = function batchGetUntilDone(err, data) {
                    if (err) {
                      var _returnedItems;

                      if ((_returnedItems = returnedItems) === null || _returnedItems === void 0 ? void 0 : _returnedItems.length) {
                        resolve(returnedItems);
                      } else {
                        reject(err.stack);
                      }
                    } else {
                      if (data === null || data === void 0 ? void 0 : data.Responses) {
                        var itemListRaw = data.Responses[tableFullName];
                        var itemList = itemListRaw.map(function (item) {
                          return _classPrivateFieldGet(_this3, _marshaller).unmarshallItem(item);
                        });
                        returnedItems = [].concat(_toConsumableArray(returnedItems), _toConsumableArray(itemList));
                      }

                      if (data === null || data === void 0 ? void 0 : data.UnprocessedKeys) {
                        var _params = {
                          RequestItems: data.UnprocessedKeys
                        };
                        console.log({
                          dynamoBatchGetParams: _params
                        });

                        _this3._dynamoDb().batchGetItem(_params, batchGetUntilDone);
                      } else {
                        resolve(returnedItems);
                      }
                    }
                  };

                  _this3._dynamoDb().batchGetItem(params, batchGetUntilDone);
                }));

              case 3:
              case "end":
                return _context20.stop();
            }
          }
        }, _callee19);
      }));

      function allBatchGetManyByHashAndSortKey(_x14) {
        return _allBatchGetManyByHashAndSortKey.apply(this, arguments);
      }

      return allBatchGetManyByHashAndSortKey;
    }()
  }, {
    key: "allQueryBySecondaryIndexPaginateBase",
    value: function () {
      var _allQueryBySecondaryIndexPaginateBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee20(_ref12) {
        var _sortKeyQueryOptions$;

        var _ref12$keyQueryEquals, keyFieldName, value, secondaryIndexName, orderDesc, sortKeyQueryOptions, _this$_getLocalVariab16, tableFullName, secondaryIndexOptions, secondaryIndex, hasField, paramOptions, _this$__helperDynamoF, expressionAttributeValues, filterExpression, projectionExpressionAttr, expressionAttributeNames, params, hashKeyName, sortKeyName, hashKeyAndSortKey, pagingParams, result;

        return regeneratorRuntime.wrap(function _callee20$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                _ref12$keyQueryEquals = _ref12.keyQueryEquals, keyFieldName = _ref12$keyQueryEquals.keyFieldName, value = _ref12$keyQueryEquals.value, secondaryIndexName = _ref12.secondaryIndexName, orderDesc = _ref12.orderDesc, sortKeyQueryOptions = _ref12.sortKeyQueryOptions;
                _this$_getLocalVariab16 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab16.tableFullName, secondaryIndexOptions = _this$_getLocalVariab16.secondaryIndexOptions;

                if (secondaryIndexOptions === null || secondaryIndexOptions === void 0 ? void 0 : secondaryIndexOptions.length) {
                  _context21.next = 4;
                  break;
                }

                throw new _errors.GenericDataError("Invalid secondary index definitions");

              case 4:
                secondaryIndex = secondaryIndexOptions.find(function (_ref13) {
                  var indexName = _ref13.indexName;
                  return secondaryIndexName === indexName;
                });

                if (secondaryIndex) {
                  _context21.next = 7;
                  break;
                }

                throw new _errors.GenericDataError("Invalid secondary index name");

              case 7:
                hasField = secondaryIndex.keyFieldName === keyFieldName;

                if (hasField) {
                  _context21.next = 10;
                  break;
                }

                throw new _errors.GenericDataError("Invalid secondary index field definitions");

              case 10:
                paramOptions = {
                  query: _objectSpread(_objectSpread({}, (_sortKeyQueryOptions$ = sortKeyQueryOptions === null || sortKeyQueryOptions === void 0 ? void 0 : sortKeyQueryOptions.query) !== null && _sortKeyQueryOptions$ !== void 0 ? _sortKeyQueryOptions$ : {}), _defineProperty({}, keyFieldName, value)),
                  fields: sortKeyQueryOptions === null || sortKeyQueryOptions === void 0 ? void 0 : sortKeyQueryOptions.fields
                };
                _this$__helperDynamoF = this.__helperDynamoFilterOperation({
                  queryDefs: paramOptions.query,
                  projectionFields: paramOptions.fields
                }), expressionAttributeValues = _this$__helperDynamoF.expressionAttributeValues, filterExpression = _this$__helperDynamoF.filterExpression, projectionExpressionAttr = _this$__helperDynamoF.projectionExpressionAttr, expressionAttributeNames = _this$__helperDynamoF.expressionAttributeNames;
                params = {
                  TableName: tableFullName,
                  IndexName: secondaryIndexName,
                  KeyConditionExpression: filterExpression,
                  //
                  ExpressionAttributeValues: expressionAttributeValues,
                  ExpressionAttributeNames: expressionAttributeNames
                };

                if (orderDesc === true) {
                  params.ScanIndexForward = false;
                }

                if (projectionExpressionAttr) {
                  params.ProjectionExpression = projectionExpressionAttr;
                }

                hashKeyName = secondaryIndex.keyFieldName;
                sortKeyName = secondaryIndex.sortFieldName;
                hashKeyAndSortKey = [hashKeyName, sortKeyName];
                pagingParams = _objectSpread({}, paramOptions.pagingParams);
                _context21.next = 21;
                return this.__helperDynamoQueryProcessor(_objectSpread({
                  params: params,
                  orderDesc: orderDesc,
                  hashKeyAndSortKey: hashKeyAndSortKey
                }, pagingParams));

              case 21:
                result = _context21.sent;
                return _context21.abrupt("return", result);

              case 23:
              case "end":
                return _context21.stop();
            }
          }
        }, _callee20, this);
      }));

      function allQueryBySecondaryIndexPaginateBase(_x15) {
        return _allQueryBySecondaryIndexPaginateBase.apply(this, arguments);
      }

      return allQueryBySecondaryIndexPaginateBase;
    }()
  }, {
    key: "allDeleteByIdBase",
    value: function () {
      var _allDeleteByIdBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee21(_ref14) {
        var _Key3;

        var dataId, _this$_getLocalVariab17, tableFullName, partitionKeyFieldName, sortKeyFieldName, segmentPartitionValue, dataExist, params;

        return regeneratorRuntime.wrap(function _callee21$(_context22) {
          while (1) {
            switch (_context22.prev = _context22.next) {
              case 0:
                dataId = _ref14.dataId;
                //
                this.allHelpValidateRequiredString({
                  Del1SortKey: dataId
                });
                _this$_getLocalVariab17 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab17.tableFullName, partitionKeyFieldName = _this$_getLocalVariab17.partitionKeyFieldName, sortKeyFieldName = _this$_getLocalVariab17.sortKeyFieldName, segmentPartitionValue = _this$_getLocalVariab17.segmentPartitionValue;
                _context22.next = 5;
                return this.allDeleteByIdBase({
                  dataId: dataId
                });

              case 5:
                dataExist = _context22.sent;

                if (dataExist && dataExist[sortKeyFieldName]) {
                  _context22.next = 8;
                  break;
                }

                throw new _errors.GenericDataError("Record does NOT exists");

              case 8:
                params = {
                  TableName: tableFullName,
                  Key: (_Key3 = {}, _defineProperty(_Key3, partitionKeyFieldName, segmentPartitionValue), _defineProperty(_Key3, sortKeyFieldName, dataId), _Key3)
                };
                _context22.next = 11;
                return this._dynamoDbClient()["delete"](params).promise();

              case 11:
                return _context22.abrupt("return", dataExist);

              case 12:
              case "end":
                return _context22.stop();
            }
          }
        }, _callee21, this);
      }));

      function allDeleteByIdBase(_x16) {
        return _allDeleteByIdBase.apply(this, arguments);
      }

      return allDeleteByIdBase;
    }()
  }, {
    key: "allDeleteManyDangerouselyByIds",
    value: function () {
      var _allDeleteManyDangerouselyByIds = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee22(_ref15) {
        var _this4 = this;

        var dataIds, _this$_getLocalVariab18, tableFullName, partitionKeyFieldName, sortKeyFieldName, segmentPartitionValue, delArray, params;

        return regeneratorRuntime.wrap(function _callee22$(_context23) {
          while (1) {
            switch (_context23.prev = _context23.next) {
              case 0:
                dataIds = _ref15.dataIds;
                //
                dataIds.forEach(function (sortKeyValue) {
                  _this4.allHelpValidateRequiredString({
                    DelSortKey: sortKeyValue
                  });
                });
                _this$_getLocalVariab18 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab18.tableFullName, partitionKeyFieldName = _this$_getLocalVariab18.partitionKeyFieldName, sortKeyFieldName = _this$_getLocalVariab18.sortKeyFieldName, segmentPartitionValue = _this$_getLocalVariab18.segmentPartitionValue;
                delArray = dataIds.map(function (sortKeyValue) {
                  var _Key4;

                  var params01 = {
                    DeleteRequest: {
                      Key: (_Key4 = {}, _defineProperty(_Key4, partitionKeyFieldName, {
                        S: segmentPartitionValue
                      }), _defineProperty(_Key4, sortKeyFieldName, {
                        S: sortKeyValue
                      }), _Key4)
                    }
                  };
                  return params01;
                });
                params = {
                  RequestItems: _defineProperty({}, tableFullName, delArray)
                };
                _context23.next = 7;
                return this._dynamoDb().batchWriteItem(params).promise();

              case 7:
                return _context23.abrupt("return", true);

              case 8:
              case "end":
                return _context23.stop();
            }
          }
        }, _callee22, this);
      }));

      function allDeleteManyDangerouselyByIds(_x17) {
        return _allDeleteManyDangerouselyByIds.apply(this, arguments);
      }

      return allDeleteManyDangerouselyByIds;
    }()
  }]);

  return DynamoDataOperation;
}(_baseMixins["default"]);

exports.DynamoDataOperation = DynamoDataOperation;