"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DynamoFilterQueryOperation = void 0;

var _loggingService = require("../helpers/logging-service.js");

var _utilService = require("../helpers/util-service.js");

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var conditionKeyMap = {
  $eq: "=",
  $notEq: "<>",
  $lt: "<",
  $lte: "<=",
  $gt: ">",
  $gte: ">=",
  $exists: "",
  $notExists: "",
  $in: "",
  $between: "",
  $contains: "",
  $notContains: "",
  $beginsWith: ""
};

function hasQueryConditionKey(key) {
  var queryCondKeys = Object.keys(conditionKeyMap);
  return queryCondKeys.includes(key);
}

var getRandom = function getRandom() {
  return [Math.round(Math.random() * 99999), Math.round(Math.random() * 88888), Math.round(Math.random() * 99)].join("");
};

var DynamoFilterQueryOperation = /*#__PURE__*/function () {
  function DynamoFilterQueryOperation() {
    _classCallCheck(this, DynamoFilterQueryOperation);
  }

  _createClass(DynamoFilterQueryOperation, [{
    key: "operation__filterFieldExist",
    value: function operation__filterFieldExist(_ref) {
      var fieldName = _ref.fieldName;
      var attrKeyHash = "#attrKey1".concat(getRandom()).toLowerCase();
      var result = {
        xExpressionAttributeNames: _defineProperty({}, attrKeyHash, fieldName),
        xFilterExpression: "attribute_exists (".concat(attrKeyHash, ")")
      };
      return result;
    }
  }, {
    key: "operation__filterFieldNotExist",
    value: function operation__filterFieldNotExist(_ref2) {
      var fieldName = _ref2.fieldName;
      var attrKeyHash = "#attrKey2".concat(getRandom()).toLowerCase();
      var result = {
        xExpressionAttributeNames: _defineProperty({}, attrKeyHash, fieldName),
        xFilterExpression: "attribute_not_exists (".concat(attrKeyHash, ")")
      };
      return result;
    }
  }, {
    key: "__helperFilterBasic",
    value: function __helperFilterBasic(_ref3) {
      var fieldName = _ref3.fieldName,
          val = _ref3.val,
          conditionExpr = _ref3.conditionExpr;
      var keyAttr = ":attr".concat(fieldName).concat(getRandom()).toLowerCase();
      var attrKeyHash = "#attrKey3".concat(getRandom()).toLowerCase();
      var result = {
        xExpressionAttributeValues: _defineProperty({}, keyAttr, val),
        xExpressionAttributeNames: _defineProperty({}, attrKeyHash, fieldName),
        xFilterExpression: [attrKeyHash, conditionExpr, keyAttr].join(" ")
      };
      return result;
    }
  }, {
    key: "operation__filterIn",
    value: function operation__filterIn(_ref4) {
      var fieldName = _ref4.fieldName,
          attrValues = _ref4.attrValues;
      var expressAttrVal = {};
      var expressAttrName = {};
      var filterExpress = [];

      var _attrKeyHash = "#attrKey4".concat(getRandom()).toLowerCase();

      expressAttrName[_attrKeyHash] = fieldName;
      attrValues.forEach(function (item) {
        var keyAttr = ":attr".concat(fieldName).concat(getRandom()).toLowerCase();
        expressAttrVal[keyAttr] = item;
        filterExpress.push("".concat(_attrKeyHash, " = ").concat(keyAttr));
      });

      var _filterExpression = filterExpress.join(" OR ").trim();

      var _filterExpressionValue = filterExpress.length > 1 ? "(".concat(_filterExpression, ")") : _filterExpression;

      var result = {
        xExpressionAttributeValues: _objectSpread({}, expressAttrVal),
        xExpressionAttributeNames: _objectSpread({}, expressAttrName),
        xFilterExpression: _filterExpressionValue
      };
      return result;
    }
  }, {
    key: "operation__filterContains",
    value: function operation__filterContains(_ref5) {
      var fieldName = _ref5.fieldName,
          term = _ref5.term;
      var attrKeyHash = "#attrKey5".concat(getRandom()).toLowerCase();
      var keyAttr = ":attr".concat(fieldName).concat(getRandom()).toLowerCase();
      var result = {
        xExpressionAttributeValues: _defineProperty({}, keyAttr, term),
        xExpressionAttributeNames: _defineProperty({}, attrKeyHash, fieldName),
        xFilterExpression: "contains (".concat(attrKeyHash, ", ").concat(keyAttr, ")")
      };
      return result;
    }
  }, {
    key: "operation__filterBetween",
    value: function operation__filterBetween(_ref6) {
      var _xExpressionAttribute7;

      var fieldName = _ref6.fieldName,
          from = _ref6.from,
          to = _ref6.to;

      var _attrKeyHash = "#attrKey6".concat(getRandom()).toLowerCase();

      var _fromKey = ":fromKey".concat(getRandom()).toLowerCase();

      var _toKey = ":toKey".concat(getRandom()).toLowerCase();

      var result = {
        xExpressionAttributeValues: (_xExpressionAttribute7 = {}, _defineProperty(_xExpressionAttribute7, _fromKey, from), _defineProperty(_xExpressionAttribute7, _toKey, to), _xExpressionAttribute7),
        xExpressionAttributeNames: _defineProperty({}, _attrKeyHash, fieldName),
        xFilterExpression: [_attrKeyHash, "between", _fromKey, "and", _toKey].join(" ")
      };
      return result;
    }
  }, {
    key: "operation__filterBeginsWith",
    value: function operation__filterBeginsWith(_ref7) {
      var fieldName = _ref7.fieldName,
          term = _ref7.term;

      var _attrKeyHash = "#attrKey7".concat(getRandom()).toLowerCase();

      var keyAttr = ":attr".concat(fieldName).concat(getRandom()).toLowerCase();
      var result = {
        xExpressionAttributeValues: _defineProperty({}, keyAttr, term),
        xExpressionAttributeNames: _defineProperty({}, _attrKeyHash, fieldName),
        xFilterExpression: "begins_with (".concat(_attrKeyHash, ", ").concat(keyAttr, ")")
      };
      return result;
    }
  }, {
    key: "operation__translateAdvancedQueryOperation",
    value: function operation__translateAdvancedQueryOperation(_ref8) {
      var _this = this;

      var fieldName = _ref8.fieldName,
          queryObject = _ref8.queryObject;
      var queryConditions = [];
      Object.keys(queryObject).forEach(function (condKey) {
        var conditionKey = condKey;
        var _conditionObjValue = queryObject[conditionKey];

        if (conditionKey === "$between") {
          if (Array.isArray(_conditionObjValue)) {
            var _queryConditions = _this.operation__filterBetween({
              fieldName: fieldName,
              from: _conditionObjValue[0],
              to: _conditionObjValue[1]
            });

            queryConditions.push(_queryConditions);
          }
        } else if (conditionKey === "$beginsWith") {
          var _queryConditions2 = _this.operation__filterBeginsWith({
            fieldName: fieldName,
            term: _conditionObjValue
          });

          queryConditions.push(_queryConditions2);
        } else if (conditionKey === "$contains") {
          var _queryConditions3 = _this.operation__filterContains({
            fieldName: fieldName,
            term: _conditionObjValue
          });

          queryConditions.push(_queryConditions3);
        } else if (conditionKey === "$in") {
          if (Array.isArray(_conditionObjValue)) {
            var _queryConditions4 = _this.operation__filterIn({
              fieldName: fieldName,
              attrValues: _conditionObjValue
            });

            queryConditions.push(_queryConditions4);
          } // filterFieldNotExist({ fieldName, termValue }

        } else if (conditionKey === "$notContains") {
          var _queryConditions5 = _this.operation__filterContains({
            fieldName: fieldName,
            term: _conditionObjValue
          });

          _queryConditions5.xFilterExpression = "NOT ".concat(_queryConditions5.xFilterExpression);
          queryConditions.push(_queryConditions5);
        } else if (conditionKey === "$exists") {
          var _queryConditions6 = _this.operation__filterFieldExist({
            fieldName: fieldName
          });

          queryConditions.push(_queryConditions6);
        } else if (conditionKey === "$notExists") {
          var _queryConditions7 = _this.operation__filterFieldNotExist({
            fieldName: fieldName
          });

          queryConditions.push(_queryConditions7);
        } else {
          if (hasQueryConditionKey(conditionKey)) {
            var conditionExpr = conditionKeyMap[conditionKey];

            if (conditionExpr) {
              var _queryConditions8 = _this.__helperFilterBasic({
                fieldName: fieldName,
                val: _conditionObjValue,
                conditionExpr: conditionExpr
              });

              queryConditions.push(_queryConditions8);
            }
          }
        }
      });
      return queryConditions;
    }
  }, {
    key: "operation_translateBasicQueryOperation",
    value: function operation_translateBasicQueryOperation(_ref9) {
      var fieldName = _ref9.fieldName,
          queryObject = _ref9.queryObject;

      var _queryConditions = this.__helperFilterBasic({
        fieldName: fieldName,
        val: queryObject,
        conditionExpr: "="
      });

      return _queryConditions;
    }
  }, {
    key: "__helperDynamoFilterOperation",
    value: function __helperDynamoFilterOperation(_ref10) {
      var _this2 = this;

      var queryDefs = _ref10.queryDefs,
          projectionFields = _ref10.projectionFields;
      var queryAndConditions = [];
      var queryOrConditions = []; //

      var _projectionExpression = undefined;
      var andFilterExpressionArray = [];
      var orFilterExpressionArray = [];
      var _expressionAttributeValues = {};
      var _expressionAttributeNames = {};
      Object.keys(queryDefs).forEach(function (fieldName_or_$or) {
        if (fieldName_or_$or === "$or") {
          var $orKey = fieldName_or_$or;
          var orArray = queryDefs[$orKey];

          if (Array.isArray(orArray)) {
            orArray.forEach(function (orQuery) {
              Object.keys(orQuery).forEach(function (fieldName) {
                //
                var orQueryObjectOrValue = orQuery[fieldName]; //

                if (_typeof(orQueryObjectOrValue) === "object") {
                  var _orQueryCond = _this2.operation__translateAdvancedQueryOperation({
                    fieldName: fieldName,
                    queryObject: orQueryObjectOrValue
                  });

                  queryOrConditions = [].concat(_toConsumableArray(queryOrConditions), _toConsumableArray(_orQueryCond));
                } else {
                  var _orQueryConditions = _this2.operation_translateBasicQueryOperation({
                    fieldName: fieldName,
                    queryObject: orQueryObjectOrValue
                  });

                  queryOrConditions = [].concat(_toConsumableArray(queryOrConditions), [_orQueryConditions]);
                }
              });
            });
          }
        } else {
          var fieldName2 = fieldName_or_$or;
          var queryObjectOrValue = queryDefs[fieldName2];

          if (_typeof(queryObjectOrValue) === "object") {
            var _queryCond = _this2.operation__translateAdvancedQueryOperation({
              fieldName: fieldName2,
              queryObject: queryObjectOrValue
            });

            queryAndConditions = [].concat(_toConsumableArray(queryAndConditions), _toConsumableArray(_queryCond));
          } else {
            var _queryConditions = _this2.operation_translateBasicQueryOperation({
              fieldName: fieldName2,
              queryObject: queryObjectOrValue
            });

            queryAndConditions = [].concat(_toConsumableArray(queryAndConditions), [_queryConditions]);
          }
        }
      });

      var _iterator = _createForOfIteratorHelper(queryAndConditions),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var item = _step.value;
          _expressionAttributeNames = _objectSpread(_objectSpread({}, _expressionAttributeNames), item.xExpressionAttributeNames);
          _expressionAttributeValues = _objectSpread(_objectSpread({}, _expressionAttributeValues), item.xExpressionAttributeValues);
          andFilterExpressionArray.push(item.xFilterExpression);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      var _iterator2 = _createForOfIteratorHelper(queryOrConditions),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var item2 = _step2.value;
          _expressionAttributeNames = _objectSpread(_objectSpread({}, _expressionAttributeNames), item2.xExpressionAttributeNames);
          _expressionAttributeValues = _objectSpread(_objectSpread({}, _expressionAttributeValues), item2.xExpressionAttributeValues);
          orFilterExpressionArray.push(item2.xFilterExpression);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }

      var _andfilterExpression = null;
      var _orfilterExpression = null;

      if (andFilterExpressionArray === null || andFilterExpressionArray === void 0 ? void 0 : andFilterExpressionArray.length) {
        _andfilterExpression = andFilterExpressionArray.join(" AND ").trim();
      }

      if (orFilterExpressionArray === null || orFilterExpressionArray === void 0 ? void 0 : orFilterExpressionArray.length) {
        _orfilterExpression = orFilterExpressionArray.join(" OR ").trim();
      }

      var _filterExpression = "";

      if (_andfilterExpression && _orfilterExpression) {
        _filterExpression = "(".concat(_andfilterExpression, ") AND (").concat(_orfilterExpression, ")"); //
      } else if (_andfilterExpression) {
        _filterExpression = _andfilterExpression; //
      } else if (_orfilterExpression) {
        _filterExpression = _orfilterExpression;
      }

      if ((projectionFields === null || projectionFields === void 0 ? void 0 : projectionFields.length) && Array.isArray(projectionFields)) {
        var _projection_expressionAttributeNames = {};
        projectionFields.forEach(function (field) {
          if (typeof field === "string") {
            var attrKeyHash = "#attrKey8".concat(getRandom()).toLowerCase();
            _projection_expressionAttributeNames[attrKeyHash] = field;
          }
        });
        _projectionExpression = Object.keys(_projection_expressionAttributeNames).join(", ");
        _expressionAttributeNames = _objectSpread(_objectSpread({}, _projection_expressionAttributeNames), _expressionAttributeNames);
      }

      var _expressionAttributeValuesFinal = _utilService.UtilService.objectHasAnyProperty(_expressionAttributeValues) ? _expressionAttributeValues : undefined; //


      var _expressionAttributeNamesFinal = _utilService.UtilService.objectHasAnyProperty(_expressionAttributeNames) ? _expressionAttributeNames : undefined;

      var queryExpressions = {
        expressionAttributeValues: _expressionAttributeValuesFinal,
        filterExpression: _filterExpression,
        projectionExpressionAttr: _projectionExpression,
        expressionAttributeNames: _expressionAttributeNamesFinal
      };

      _loggingService.LoggingService.log({
        queryExpressions: queryExpressions
      });

      return queryExpressions;
    }
  }]);

  return DynamoFilterQueryOperation;
}();

exports.DynamoFilterQueryOperation = DynamoFilterQueryOperation;